# Created by Matyáš Pokorný on 2018-01-20.

module KXI
	module CLI
		# Represents argument specified explicitly with name
		class ExplicitArgument < KXI::CLI::Argument
			# Gets full descriptive name of argument
			# @return [String] Full name of argument
			def headline
				ret = ''
				ret = "-#{@sh}, " if @sh != nil
				ret += "--#{name}"
				return ret
			end
			
			# Gets syntax of argument
			# @return [String] Syntax of argument
			def syntax
				headline
			end
			
			# Gets the shortcut symbol of argument
			# @return [String] Shortcut symbol of argument
			def shortcut
				@sh
			end
			
			# Instantiates the {KXI::CLI::ExplicitArgument} class
			# @param nm [String] Name of argument
			# @param desc [String] Description of argument
			# @param sh [String, nil] Shortcut of argument
			# @param req [Bool] Specifies whether argument is mandatory
			def initialize(nm, desc, sh = nil, req = false)
				super(nm, desc, req, req ? 2 : 1)
				@sh = sh
			end
		end
	end
end