# Created by Matyáš Pokorný on 2017-12-28.

module KXI
	module Collections
		# Allows iteration over a collection
		# @abstract
		class Enumerator
			# Selects first item in collection
			# @return [Bool] True if collection contains elements; otherwise false
			# @abstract
			def rewind
				raise(KXI::Exceptions::AbstractException.new(Enumerator))
			end
			
			# Advances enumerator to next item
			# @return [Bool] True if item is available; false otherwise
			# @raise [KXI::Exceptions::AbstractException] When method is not implemented in superclass
			# @abstract
			def next
				raise(KXI::Exceptions::AbstractException.new(Enumerator))
			end
			
			# Returns current item
			# @return [Object] Current item
			# @raise [KXI::Exceptions::AbstractException] When method is not implemented in superclass
			# @abstract
			def current
				raise(KXI::Exceptions::AbstractException.new(Enumerator))
			end
		end
	end
end