# Created by Matyáš Pokorný on 2018-01-20.

module KXI
	module Collections
		# Represents a collection that can only be enumerated
		class ProtectedCollection < KXI::Collections::Enumerable
			# Instantiates the {KXI::Collections::ArrayCollection} class
			# @param enum [KXI::Collections::Enumerable] Protected enumerable
			def initialize(enum = [])
				super()
				@enum = enum
			end
			
			# Creates a new {KXI::Collections::Enumerator} bound to this instance
			# @return [KXI::Collections::Enumerator] Enumerator bound to this instance
			def create_enumerator
				@enum.create_enumerator
			end
		end
	end
end