# Created by Matyáš Pokorný on 2017-12-28.
module KXI
	module Exceptions
		# Raised when method that was supposed to be implemented by super class wasn't
		class AbstractException < Exception
			# Returns the abstract class
			# @return [Class] Abstract class
			def class
				@class
			end
			
			# Returns the file that contains the abstract class
			# @return [String] Path of file that contains the abstract class
			def file
				@file
			end
			
			# Returns name of the abstract method
			# @return [String] Name of the abstract method
			def method
				@mtd
			end
			
			# Instantiates the {KXI::Exceptions::AbstractException} class
			# @param cl [Class] Abstract class
			def initialize(cl)
				frame = Reflection::StackFrame.callstack(3).first
				@file = frame.file
				@mtd = frame.method
				super("Abstract method #{cl.name}##{@mtd} wasn't implemented!")
				@class = cl
			end
		end
	end
end