# Created by Matyáš Pokorný on 2018-01-24.

module KXI
	module Exceptions
		# Raised on error during configuration file reading
		class ConfigurationException < Exception
			# Gets the path of the configuration file
			# @return [string] Path of the configuration file
			def file
				@file
			end
			
			# Gets the path of the configuration parameter
			# @return [string] Path of the configuration parameter
			def path
				@path
			end
			
			# Gets the message of error
			# @return [string] Message of error
			def error_message
				@msg
			end
			
			# Instantiates the {KXI::Exceptions::ConfigurationException} class
			# @param [string] file Path of the configuration file
			# @param [string] path Path of the configuration parameter
			# @param [string,nil] msg Message of error
			def initialize(file, path, msg = nil)
				super("Invalid configuration <#{path}> in file '#{file}'!#{msg != nil ? ": #{msg}" : ''}")
				@file = file
				@path = path
				@msg = msg
			end
		end
	end
end