# Created by Matyáš Pokorný on 2018-04-14.

module KXI
	module Exceptions
		# Raised when matrices or vectors are of incompatible dimensions during operation
		class DimensionMismatchException < Exception
			# Gets the expected dimension
			# @return [integer] Expected dimension
			def expected
				@ex
			end
			
			# Gets the actual dimension
			# @return [integer] Actual dimension
			def actual
				@act
			end
			
			# Instantiates the {KXI::Exceptions::DimensionMismatchException} class
			# @param [integer] act Actual dimension
			# @param [integer] ex Expected dimension
			def initialize(act, ex)
				@act = act
				@ex  = ex
				super("Expected dimension #{ex} got #{act}!")
			end
		end
	end
end