# Created by Matyáš Pokorný on 2017-12-30.

module KXI
	module Exceptions
		# Raised when some value is of unexpected type
		class InvalidTypeException < Exception
			# Returns expected types
			# @return [Array<Class>] Expected types
			def expected
				@exp
			end
			
			# Returns actual type
			# @return [Class] Actual type
			def actual
				@act
			end
			
			# Instantiates the [KXI::Exceptions::InvalidTypeException] class
			# @param exp [Array<Class>] Expected types
			# @param act [Class] Actual type
			def initialize(act, *exp)
				if exp.length == 1
					super("Value is of unexpected type! Expected <#{exp[0].name}> got <#{act.name}>")
				else
					super("Value is of unexpected type! Expected { #{exp.collect {|i| "<#{i}>"}.join(', ')} } got <#{act.name}>")
				end
				@exp = exp
				@act = act
			end
		end
	end
end