# Created by Matyáš Pokorný on 2018-01-27.

module KXI
	module Exceptions
		# Raised when parser encounters an error
		class ParseException < Exception
			# Get the parsed value
			# @return [any] Parsed value
			def value
				@val
			end
			
			# Gets the name of the parser
			# @return [string] Name of the parser
			def parser
				@par
			end
			
			# Instantiates the {KXI::Exceptions::ParseException} class
			# @param [string] parser Name of the parser
			# @param [any] val Parsed value
			def initialize(parser, val)
				super("Failed to parse value '#{val.to_s}' as #{parser}!")
				@par = parser
				@val = val
			end
		end
	end
end