# Created by Matyáš Pokorný on 2018-01-21.

module KXI
	module Exceptions
		# Raised when specific verb was expected
		class VerbExpectedException < Exception
			# Gets array of verbs that were expected
			# @return [Array<String>] Expected verbs
			def verbs
				@verbs
			end
			
			# Instantiates the {KXI::CLI::VerbExpectedException} class
			# @param verbs [Array<String>] Expected verbs
			def initialize(verbs)
				super("Expected verb! (#{verbs.join(', ')})")
				@verbs = verbs
			end
		end
	end
end