# Created by Matyáš Pokorný on 2018-03-23.

module KXI
	module Exceptions
		# Raised when part of workspace path is a file
		class WorkspaceCollisionException < Exception
			# Gets the path of workspace
			# @return [string] Path of workspace
			def path
				@path
			end
			
			# Instantiates the {KXI::Exceptions::WorkspaceCollisionException} class
			# @param [string] path Path of workspace
			def initialize(path)
				super("Workspace path '#{path}' is used by file!")
				@path = path
			end
		end
	end
end